SLASH_TOKENPRICE1, SLASH_TOKENPRICE2 = '/tp', '/tokenprice'
SLASH_TOKEN = '/token'
local icon = LibStub("LibDBIcon-1.0")
local db = LibStub("AceDB-3.0"):New("TPNDB", { profile = { minimap = { hide = true, }, }, })
local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("TokenPriceNotifier", {
    type = "data source",
    text = "TokenPriceNotifier",
    icon = "Interface\\ICONS\\WoW_Token01.PNG",
    OnTooltipShow = function(tooltip)
        C_WowTokenPublic.UpdateMarketPrice()
        if C_WowTokenPublic.GetCurrentMarketPrice() ~= nil then
            local GoldIcon = '|TInterface\\MoneyFrame\\UI-GoldIcon:14:14:2:0|t'
            if LastTokenPrice == nil then
                LastTokenPrice = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
            end
            local TokenPriceValue = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
            local TokenPriceString
            TokenPriceString = string.sub(TokenPriceValue, 1, 3) .. ',' .. string.sub(TokenPriceValue, 4, 9)
            tooltip:AddLine(" Price: " .. TokenPriceString .. GoldIcon .. " ", 0.992, 0.850, 0.050)
            tooltip:Show()
        end
    end,
    OnClick = function()
        PrintPriceCommand()
    end,
})
icon:Register("TokenPriceNotifier", LDB, db.profile.minimap)
local function LoadedAddon(self, event, ...)
    SendLoadMessage()
    C_WowTokenPublic.UpdateMarketPrice()
end
local Ticker
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", LoadedAddon)
function SendLoadMessage()
    f:UnregisterEvent("ADDON_LOADED")
    C_WowTokenPublic.UpdateMarketPrice()
    if iconhidden == nil then
        iconhidden = false
    end
    if iconhidden == true then
        db.profile.minimap.hide = true
        icon:Hide("TokenPriceNotifier")
    elseif iconhidden == false then
        db.profile.minimap.hide = false
        icon:Show("TokenPriceNotifier")
    end
    if CheckTimer == nil then
        CheckTimer = 60
    end
    local TokenIcon
    TokenIcon = '|TInterface\\ICONS\\WoW_Token01.PNG:19:19:0:0|t'
    DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. "TokenPriceNotifier Loaded!" .. TokenIcon, 0.992, 0.850, 0.050)
    Ticker = C_Timer.NewTicker(CheckTimer, PrintPriceOnChat)
end
function SlashCmdList.TOKEN(msg, editBox)
    local command, rest = msg:match("^(%S*)%s*(.-)$")
    if command == "timer" and rest ~= "" then
        CheckTimer = MinutesToSeconds(rest)
        Ticker:Cancel()
        Ticker = C_Timer.NewTicker(MinutesToSeconds(rest), PrintPriceOnChat)
        print("[TokenPriceNotifier] Setting check timer to " .. rest .. " minutes.")
        PrintPriceOnChat()
    elseif command == "hide" then
        iconhidden = true
        icon:Hide("TokenPriceNotifier")
    elseif command == "show" then
        iconhidden = false
        icon:Show("TokenPriceNotifier")
    else
        print("[TokenPriceNotifier] Commands:")
        print("/token hide (Hide minimap icon)")
        print("/token show (Show minimap icon)")
        print("/token timer <minutes> (Set checking token price to every x minutes, 1 is default.)")
        print("/tp, /tokenprice (Print current token price on chat)")
    end
end
function SlashCmdList.TOKENPRICE(msg, editbox)
    PrintPriceCommand()
end
function PrintPriceCommand()
    C_WowTokenPublic.UpdateMarketPrice()
    if C_WowTokenPublic.GetCurrentMarketPrice() ~= nil then
        local GoldIconUp = '|TInterface\\Addons\\TokenPriceNotifier\\Textures\\GoldIconUp:25:25:-5:0|t'
        local GoldIconDown = '|TInterface\\Addons\\TokenPriceNotifier\\Textures\\GoldIconDown:25:25:-5:0|t'
        local GoldIcon = '|TInterface\\Addons\\TokenPriceNotifier\\Textures\\GoldIcon:25:25:-5:0|t'
        local TokenIcon = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25|t'
        local TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-5|t'
        C_WowTokenPublic.UpdateMarketPrice()
        if LastTokenPrice == nil then
            LastTokenPrice = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
        end
        local TokenPriceValue = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
        local TokenPriceString
        TokenPriceString = string.sub(TokenPriceValue, 1, 3) .. ',' .. string.sub(TokenPriceValue, 4, 9)
        if TokenPriceValue == LastTokenPrice then -- Same Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIcon .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        if TokenPriceValue < LastTokenPrice then -- Smaller Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIconDown .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        if TokenPriceValue > LastTokenPrice then -- Higher Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIconUp .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        LastTokenPrice = TokenPriceValue
end
end
function MinutesToSeconds(minutes)
    local seconds = minutes * 60
    return seconds
end
function PrintPriceOnChat()
    C_WowTokenPublic.UpdateMarketPrice()
    if C_WowTokenPublic.GetCurrentMarketPrice() ~= nil then
        local GoldIconUp = '|TInterface\\Addons\\TokenPriceNotifier\\Textures\\GoldIconUp:25:25:-5:0|t'
        local GoldIconDown = '|TInterface\\Addons\\TokenPriceNotifier\\Textures\\GoldIconDown:25:25:-5:0|t'
        local GoldIcon = '|TInterface\\Addons\\TokenPriceNotifier\\Textures\\GoldIcon:25:25:-5:0|t'
        local TokenIcon = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25|t'
        local TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-5|t'
        if LastTokenPrice == nil then
            LastTokenPrice = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
        end
        local TokenPriceValue = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
        local TokenPriceString
        TokenPriceString = string.sub(TokenPriceValue, 1, 3) .. ',' .. string.sub(TokenPriceValue, 4, 9)
        if TokenPriceValue < LastTokenPrice then -- Smaller Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIconDown .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        if TokenPriceValue > LastTokenPrice then -- Higher Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIconUp .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        LastTokenPrice = TokenPriceValue
    end
end